"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var tslib_1 = require("tslib");
var dappchain_client_1 = require("./dappchain-client");
var bn_js_1 = tslib_1.__importDefault(require("bn.js"));
var CachedDAppChainPlasmaClient = /** @class */ (function (_super) {
    tslib_1.__extends(CachedDAppChainPlasmaClient, _super);
    function CachedDAppChainPlasmaClient(params) {
        var _this = this;
        var dAppClient = params.dAppClient, callerAddress = params.callerAddress, database = params.database, _a = params.contractName, contractName = _a === void 0 ? 'plasmacash' : _a;
        _this = _super.call(this, { dAppClient: dAppClient, callerAddress: callerAddress, contractName: contractName }) || this;
        _this._database = database;
        return _this;
    }
    CachedDAppChainPlasmaClient.prototype.getPlasmaTxAsync = function (slot, blockNum) {
        return tslib_1.__awaiter(this, void 0, void 0, function () {
            var tx;
            return tslib_1.__generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        if (!this._database.exists(slot.toString(16), blockNum.toString())) return [3 /*break*/, 1];
                        tx = this._database.getTx(slot.toString(16), blockNum.toString());
                        return [3 /*break*/, 3];
                    case 1: return [4 /*yield*/, _super.prototype.getPlasmaTxAsync.call(this, slot, blockNum)];
                    case 2:
                        tx = _a.sent();
                        this._database.receiveCoin(slot.toString(16), blockNum.toString(), tx);
                        _a.label = 3;
                    case 3: return [2 /*return*/, tx];
                }
            });
        });
    };
    CachedDAppChainPlasmaClient.prototype.getAllCoins = function () {
        var coins = this._database.getAllCoins();
        // Get unique keys, O(N) complexity, can't go lower
        var unique = {};
        var distinct = [];
        for (var i in coins) {
            if (typeof unique[coins[i].slot] == 'undefined') {
                distinct.push(coins[i].age);
            }
            unique[coins[i].age] = 0;
        }
        // @ts-ignore
        return distinct.map(function (s) { return new bn_js_1.default(s, 16); });
    };
    return CachedDAppChainPlasmaClient;
}(dappchain_client_1.DAppChainPlasmaClient));
exports.CachedDAppChainPlasmaClient = CachedDAppChainPlasmaClient;
//# sourceMappingURL=cached-dappchain-client.js.map