import { PlasmaCashTx } from './plasma-cash-tx';
import BN from 'bn.js';
export interface IDatabaseCoin {
    slot: BN;
    blockNumber: BN;
    tx: PlasmaCashTx;
}
declare class PlasmaDB {
    db: any;
    constructor(ethereum: String, dappchain: String, plasmaAddress: String, privateKey: String);
    receiveCoin(coinId: string, block: string, tx: PlasmaCashTx): void;
    getTx(coinId: string, block: string): PlasmaCashTx;
    exists(coinId: string, block: string): Boolean;
    removeCoin(coinId: string): void;
    getCoin(coinId: string): IDatabaseCoin[];
    getAllCoins(): any;
}
export default PlasmaDB;
